// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRBase_Allocator.cc,v 1.2 1999/03/09 20:48:31 dmartin Exp $
// 
//---------------------------------------------------------------------------

#include "IIRBase_Allocator.hh"
#include "savant.hh"
#include "IIR_TypeDefinition.hh"

IIRBase_Allocator::IIRBase_Allocator(){
  set_type_mark( NULL );
  set_value(NULL);
}

IIRBase_Allocator::~IIRBase_Allocator(){
  delete get_type_mark();
  delete get_value();
}

void 
IIRBase_Allocator::set_type_mark( IIR_TypeDefinition *type_mark ){
  this->type_mark = type_mark;
}


IIR_TypeDefinition *
IIRBase_Allocator::get_type_mark(){
  return type_mark;
}

void 
IIRBase_Allocator::set_value( IIR *value ) {
  this->value = value;
}


IIR*
IIRBase_Allocator::get_value() {
  return value;
}
