
#ifndef IIRBASE_ASSOCIATION_ELEMENT_HH
#define IIRBASE_ASSOCIATION_ELEMENT_HH

// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Timothy J. McBrayer tmcrbaye@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRBase_AssociationElement.hh,v 1.2 1999/03/09 20:48:39 dmartin Exp $
// 
//---------------------------------------------------------------------------

#include "IIR_Tuple.hh"

class IIRBase_AssociationElement : public IIR_Tuple {

public:
  IIR_Kind get_kind() {return IIR_ASSOCIATION_ELEMENT;}
  IIR_Char *get_kind_text() {return "IIR_AssociationElement";}

  void set_formal(IIR*);
  IIR* get_formal();

protected:
  IIRBase_AssociationElement();
  virtual ~IIRBase_AssociationElement() = 0;
    
private:
  IIR *formal;
};
#endif
