
#ifndef IIRBASE_CONFIGURATION_SPECIFICATION_HH
#define IIRBASE_CONFIGURATION_SPECIFICATION_HH

// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRBase_ConfigurationSpecification.hh,v 1.2 1999/03/09 20:49:23 dmartin Exp $
// 
//---------------------------------------------------------------------------

#include "IIR_Declaration.hh"
#include "IIR_DesignatorList.hh"
#include "IIR_AssociationList.hh"

class IIR_LibraryUnit;

class IIRBase_ConfigurationSpecification : public IIR_Declaration {

public:
  IIR_Kind get_kind() {return IIR_CONFIGURATION_SPECIFICATION;}
  IIR_Char *get_kind_text() {return "IIR_ConfigurationSpecification";}
  
  void set_component_name(IIR *component_name);
  IIR *get_component_name();

  void set_entity_aspect(IIR_LibraryUnit    *entity_aspect);
  IIR_LibraryUnit *get_entity_aspect();
  
  IIR_DesignatorList  instantiation_list;
  IIR_AssociationList    generic_map_aspect;
  IIR_AssociationList    port_map_aspect;

protected:
  IIRBase_ConfigurationSpecification();
  virtual ~IIRBase_ConfigurationSpecification() = 0;
    
private:
  IIR              *component_name;
  IIR_LibraryUnit  *entity_aspect;
};
#endif
