#ifndef IIRSCRAM_CONCURRENT_STATEMENT_LIST_HH
#define IIRSCRAM_CONCURRENT_STATEMENT_LIST_HH

// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu
//          Narayanan Thondugulam nthondug@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRScram_ConcurrentStatementList.hh,v 1.2 1999/03/09 20:53:41 dmartin Exp $
// 
//---------------------------------------------------------------------------
#include "IIRBase_ConcurrentStatementList.hh"

class IIRScram_ConcurrentStatementList : public IIRBase_ConcurrentStatementList {
public:
  void _publish_cc();
  void _publish_cc_type_info();
  void _publish_cc_extern_type_info();

  IIR_Label *_find_instantiate_label( IIR_SimpleName * );
  void _type_check_instantiate_statements();

  int _get_number_of_component_instantiations();
  
protected:
  IIRScram_ConcurrentStatementList() {};
  virtual ~IIRScram_ConcurrentStatementList() = 0;
    
private:
};
#endif
