
#ifndef IIRSCRAM_QUALIFIED_EXPRESSION_HH
#define IIRSCRAM_QUALIFIED_EXPRESSION_HH

// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Umesh Kumar V. Rajasekaran urajasek@ece.uc.edu
//          Radharamanan Radhakrishnan  ramanan@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRScram_QualifiedExpression.hh,v 
// 
//---------------------------------------------------------------------------

#include "IIRBase_QualifiedExpression.hh"
template <class type> class set;
class IIR_DesignatorList;

class IIRScram_QualifiedExpression : public IIRBase_QualifiedExpression {

public:

  void _publish_vhdl(ostream &);
  void _publish_cc();
  void _publish_cc_headers();
  void _get_list_of_input_signals(set<IIR_Declaration>* list);
  void _build_sensitivity_list(IIR_DesignatorList* sensitivity_list);
  void _publish_cc_initialization_value();

  void _type_check( set<IIR_TypeDefinition> * );
  set<IIR_TypeDefinition> *_get_rval_set(IIR_Boolean (IIR::*constraint_function)() = 0);
  ostream &_print( ostream &os );
  IIR *_rval_to_decl( IIR_TypeDefinition * );
  IIR_Boolean _is_resolved();
  virtual void _add_decl_into_cgen_symbol_table();
  
  virtual IIR_TypeDefinition* _get_subtype();

  IIR_Boolean _is_locally_static_primary();
  IIR_Boolean _is_globally_static_primary();
  
protected:
  
  IIRScram_QualifiedExpression() {};
  virtual ~IIRScram_QualifiedExpression() = 0;
    
private:
  

};

#endif
