// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu
//          Umesh Kumar V. Rajasekaran urajasek@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRScram_SimpleNameAttribute.cc,v 1.2 1999/03/09 20:56:42 dmartin Exp $
// 
//---------------------------------------------------------------------------

#include "IIRScram_SimpleNameAttribute.hh"
#include "IIR_Identifier.hh"

IIRScram_SimpleNameAttribute::~IIRScram_SimpleNameAttribute() {}

void 
IIRScram_SimpleNameAttribute::_publish_vhdl(ostream &_vhdl_out) {
  get_prefix()->_publish_vhdl(_vhdl_out);
  _vhdl_out << "'SIMPLE_NAME ";
}


void 
IIRScram_SimpleNameAttribute::_publish_cc() {
  _cc_out << "simple_name(";
  get_prefix()->_publish_cc();
  _cc_out << ")";
}


IIR_TextLiteral *
IIRScram_SimpleNameAttribute::_build_attribute_name() {
  char *name = "simplename";
  return IIR_Identifier::get( name, strlen(name) );
}

//void 
//IIRScram::_record() {}
//IIR * 
//IIRScram_SimpleNameAttribute::_transmute() {}
