// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu
//          Krishnan Subramani  skrish@ece.uc.edu
//          Narayanan Thondugulam nthondug@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRScram_UnitList.cc,v 1.2 1999/03/09 20:57:02 dmartin Exp $
// 
//---------------------------------------------------------------------------

#include "IIRScram_UnitList.hh"
#include "IIR_PhysicalUnit.hh"

IIRScram_UnitList::~IIRScram_UnitList() {}

void 
IIRScram_UnitList::_publish_vhdl(ostream &_vhdl_out) {
  _publish_vhdl_decl( _vhdl_out );
}


void 
IIRScram_UnitList::_publish_cc_decl() {
  IIR_PhysicalUnit* node = first();

  for(; node != NULL; node = successor(node)) {
    _cc_out << ", ";
    node->_publish_cc_name();
  }
}  


