#ifndef IIRSCRAM_WAIT_STATEMENT_HH
#define IIRSCRAM_WAIT_STATEMENT_HH
// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Umesh Kumar V. Rajasekaran urajasek@ece.uc.edu
//          Krishnan Subramani  skrish@ece.uc.edu
//          Narayanan Thondugulam nthondug@ece.uc.edu

//---------------------------------------------------------------------------
// 
// $Id: IIRScram_WaitStatement.hh,v 1.2 1999/03/09 20:57:13 dmartin Exp $
// 
//---------------------------------------------------------------------------

#include "IIRBase_WaitStatement.hh"

class IIR_DesignatorList;
class IIR_List;
class ostream;
template <class type> class set;

class IIRScram_WaitStatement : public IIRBase_WaitStatement {

public:
  void _publish_vhdl(ostream &);
  void _type_check();
  IIR *_resolve_signal_name(IIR*);
  IIR *_clone();

  // methods and data for c++ code generation
  void _publish_cc();
  void _publish_cc_wait_label();
  void _publish_cc_wait_data(IIR_Char*);
  void _publish_cc_proc_wait_data();
  void _publish_cc_wait_decl();
  void _build_wait_list(dl_list<IIRScram_WaitStatement>* );
  void _publish_cc_procedure_wait();
  IIR_Int32 wait_id;

  //methods needed for elaboration
  void _get_list_of_input_signals(set<IIR_Declaration>* list);

protected:
  IIRScram_WaitStatement() {}
  virtual ~IIRScram_WaitStatement() = 0;
    
private:
};
#endif
